#!/usr/bin/perl -w
# newick 形式を読んで，クレードに含まれる leaf をクレードの大きい順に書き出す．

use strict;
use warnings;

my $tree = '(4,(3,(2,1)))';
my @content;
my @candidates;

# それぞれのクレードに含まれる leaf を無名配列に入れる
while ($tree =~ s/\(([^\(\)]+)\)/$1/) {
  my $clade = $1;
  my @temp = split(/,/, $clade);
  push(@content, \@temp);
}

# (leaf数，content)という無名配列を作る
for (my $i = 0; $i < scalar(@content); $i++) {
  my @temp = @{$content[$i]};
  my $numLeaf = @temp;
  my @candidateTemp = ($numLeaf,\@temp);
  push(@candidates,\@candidateTemp);
}

# leaf数の大きい順に並び直す
my @sortedCandidates = sort{$b->[0] <=> $a->[0]} @candidates;

# プリントアウト
# leaf 数と content を，クレードの大きい順にプリントアウト
print "All clades\n";
foreach (@sortedCandidates) {
  my ($numLeaf,$refCont) = @$_;
  print "$numLeaf: @$refCont\n";
}

# 最小のクレードだけを選ぶ場合
my $refTemp = pop(@sortedCandidates);
my ($numLeafA,$refContA) = @$refTemp;
print "Smallest calde: $numLeafA: @$refContA\n";

exit;

